Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms

Public Partial Class Form1
	Inherits Form
	Private sdk As Ingressus.Ingressus = Nothing
	Public Sub New()
		Try
			InitializeComponent()
		Catch
		End Try
	End Sub

	Protected Sub ShowCurrentStatus(msg As String)
		Try
			If txtCurrentStatus.Text.Length >= txtCurrentStatus.MaxLength Then
				txtCurrentStatus.Text = String.Empty
			End If

			txtCurrentStatus.Text += msg & vbCr & vbLf
			txtCurrentStatus.SelectionStart = txtCurrentStatus.Text.Length
			txtCurrentStatus.ScrollToCaret()

			System.Windows.Forms.Application.DoEvents()
		Catch ex As Exception
			txtCurrentStatus.Text += ex.Message
		End Try
	End Sub

	Protected Function IsUDiskPathValid() As Boolean
		If System.IO.Directory.Exists(txtPath.Text.Trim()) Then
			Return True
		Else
			ShowCurrentStatus("Invalid uDisk Path")
			Return False
		End If
	End Function

    Private Sub btnClear_Click(sender As Object, e As EventArgs) Handles btnClear.Click
        txtCurrentStatus.Text = String.Empty
        System.Windows.Forms.Application.DoEvents()
    End Sub

	' 
'         *  P/S :
'         *  Demo is set table data One by One
'         *  You may write all data to buffer, then only use function WriteAllDataToDevice_Keylock() upload to keylock.
'         *  
'         


	#Region "User"
    Private Sub btnGetAllUser_Click(sender As Object, e As EventArgs) Handles btnGetAllUser.Click
        Try
            If IsUDiskPathValid() Then
                If sdk.Keylock_ReadAllDeviceData(txtPath.Text.Trim(), clsConst.TableName_Display_User) Then
                    Dim userid As Integer = 0
                    Dim privilege As Integer = 0
                    Dim username As String = String.Empty
                    Dim cardnum As String = String.Empty
                    Dim multicard As Integer = 0
                    Dim password As String = String.Empty
                    Dim issuetime As String = String.Empty
                    Dim expiretime As String = String.Empty

                    ShowCurrentStatus(clsConst.TableName_User_Col)
                    '"UserID,Privilege,Username,CardNum,MulticardGroup,Password,IssueTime,ExpireTime";

                    While sdk.GetUserInfo(userid, privilege, username, cardnum, multicard, password, _
                     issuetime, expiretime)
                        ShowCurrentStatus(userid & "," & privilege & "," & username & "," & cardnum & "," & multicard & "," & password & "," & issuetime & "," & expiretime)
                    End While
                Else
                    ShowCurrentStatus("No record found.")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

    Private Sub btnSetUser_Click(sender As Object, e As EventArgs) Handles btnSetUser.Click
        Try
            If IsUDiskPathValid() Then
                Dim userid As Integer = Convert.ToInt32(txtUserID.Text.Trim())
                Dim privilege As Integer = Convert.ToInt32(txtPrivilege.Text.Trim())
                Dim username As String = txtUserName.Text.Trim()
                Dim cardnum As String = txtCardNum.Text.Trim()
                Dim multicard As Integer = Convert.ToInt32(txtMulticardGroup.Text.Trim())
                Dim password As String = txtPassword.Text.Trim()
                Dim issuetime As String = Convert.ToDateTime(txtStartTime.Text.Trim()).ToString("yyyyMMdd")
                Dim expiretime As String = Convert.ToDateTime(txtExpireTime.Text.Trim()).ToString("yyyyMMdd")

                sdk.SetUserInfo(userid, privilege, username, cardnum, multicard, password, _
                 issuetime, expiretime)
                If sdk.Keylock_WriteAllDataToDevice(txtPath.Text.Trim()) Then
                    ' upload user to Ingresuss  
                    ShowCurrentStatus("Successfully upload user")
                Else
                    ShowCurrentStatus("Failed to upload user")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

    Private Sub btnClearUser_Click(sender As Object, e As EventArgs) Handles btnClearUser.Click
        Try
            If IsUDiskPathValid() Then
                If sdk.Keylock_ClearUserInfo(txtPath.Text.Trim()) Then
                    ShowCurrentStatus("Successfully clear user info")
                Else
                    ShowCurrentStatus("Failed to clear user info")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub
	#End Region

	#Region "User Access Level"

    Private Sub btnSetUserAL_Click(sender As Object, e As EventArgs) Handles btnSetUserAL.Click
        Try
            If IsUDiskPathValid() Then
                Dim userid As Integer = Convert.ToInt32(txtALUser.Text.Trim())
                Dim timezoneid As Integer = Convert.ToInt32(txtALTimezone.Text.Trim())
                Dim doorid As Integer = Convert.ToInt32(txtALDoor.Text.Trim())

                sdk.SetUserAccessLevel(userid, timezoneid, doorid)
                If sdk.Keylock_WriteAllDataToDevice(txtPath.Text.Trim()) Then
                    ShowCurrentStatus("Successfully upload user access level")
                Else
                    ShowCurrentStatus("Failed to upload user access level")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

    Private Sub btnGetAllAL_Click(sender As Object, e As EventArgs) Handles btnGetAllAL.Click
        Try
            If IsUDiskPathValid() Then
                If sdk.Keylock_ReadAllDeviceData(txtPath.Text.Trim(), clsConst.TableName_Display_UserAccessLevel) Then
                    Dim userid As Integer = 0
                    Dim timezoneid As Integer = 0
                    Dim doorid As Integer = 0

                    ShowCurrentStatus(clsConst.TableName_UserAccessLevel_Col)
                    '"UserID,AuthorizeTimezoneId,AuthorizeDoorId";

                    While sdk.GetUserAccessLevel(userid, timezoneid, doorid)
                        ShowCurrentStatus(userid & "," & timezoneid & "," & doorid)
                    End While
                Else
                    ShowCurrentStatus("No record found.")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

    Private Sub btnClearAL_Click(sender As Object, e As EventArgs) Handles btnClearAL.Click
        Try
            If IsUDiskPathValid() Then
                If sdk.Keylock_ClearUserAccessLevel(txtPath.Text.Trim()) Then
                    ShowCurrentStatus("Successfully clear access level data")
                Else
                    ShowCurrentStatus("Failed to clear access level data")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub
	#End Region

	#Region "Holiday"

    Private Sub btnSetHoliday_Click(sender As Object, e As EventArgs) Handles btnSetHoliday.Click
        Try
            If IsUDiskPathValid() Then
                Dim holiday As String = txtHoliday.Text.Trim()
                Dim holidaytype As Integer = Convert.ToInt32(txtHolidayType.Text.Trim())
                Dim [loop] As Integer = Convert.ToInt32(txtLoop.Text.Trim())

                sdk.SetHolidayData(holiday, holidaytype, [loop])
                If sdk.Keylock_WriteAllDataToDevice(txtPath.Text.Trim()) Then
                    ShowCurrentStatus("Successfully upload holiday")
                Else
                    ShowCurrentStatus("Failed to upload holiday")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

    Private Sub btnGetAllHoliday_Click(sender As Object, e As EventArgs) Handles btnGetAllHoliday.Click
        Try
            If IsUDiskPathValid() Then
                If sdk.Keylock_ReadAllDeviceData(txtPath.Text.Trim(), clsConst.TableName_Display_Holiday) Then
                    Dim holiday As String = String.Empty
                    Dim holidaytype As Integer = 0
                    Dim [loop] As Integer = 0

                    ShowCurrentStatus(clsConst.TableName_Holiday_Col)
                    '"Holiday,HolidayType,Loop";

                    While sdk.GetHolidayData(holiday, holidaytype, [loop])
                        ShowCurrentStatus(holiday & "," & holidaytype & "," & [loop])
                    End While
                Else
                    ShowCurrentStatus("No record found.")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

    Private Sub button4_Click(sender As Object, e As EventArgs) Handles btnClearHol.Click
        Try
            If IsUDiskPathValid() Then
                If sdk.Keylock_ClearHolidayData(txtPath.Text.Trim()) Then
                    ShowCurrentStatus("Successfully clear holiday data")
                Else
                    ShowCurrentStatus("Failed to clear holiday data")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

	#End Region

	#Region "Timezone"

    Private Sub btnSetTimezone_Click(sender As Object, e As EventArgs) Handles btnSetTimezone.Click
        Try
            If IsUDiskPathValid() Then
                Dim TimezoneId As Integer = Convert.ToInt32(txtTimezoneID.Text.Trim())
                Dim SunTime1 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSun1S.Text.Trim() & txtSun1E.Text.Trim())
                ' starttime + endtime, must be 8digits
                Dim SunTime2 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSun2S.Text.Trim() & txtSun2E.Text.Trim())
                Dim SunTime3 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSun3S.Text.Trim() & txtSun3E.Text.Trim())
                Dim MonTime1 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtMon1S.Text.Trim() & txtMon1E.Text.Trim())
                Dim MonTime2 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtMon2S.Text.Trim() & txtMon2E.Text.Trim())
                Dim MonTime3 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtMon3S.Text.Trim() & txtMon3E.Text.Trim())
                Dim TueTime1 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtTue1S.Text.Trim() & txtTue1E.Text.Trim())
                Dim TueTime2 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtTue2S.Text.Trim() & txtTue2E.Text.Trim())
                Dim TueTime3 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtTue3S.Text.Trim() & txtTue3E.Text.Trim())
                Dim WedTime1 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtWed1S.Text.Trim() & txtWed1E.Text.Trim())
                Dim WedTime2 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtWed2S.Text.Trim() & txtWed2E.Text.Trim())
                Dim WedTime3 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtWed3S.Text.Trim() & txtWed3E.Text.Trim())
                Dim ThuTime1 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtThu1S.Text.Trim() & txtThu1E.Text.Trim())
                Dim ThuTime2 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtThu2S.Text.Trim() & txtThu2E.Text.Trim())
                Dim ThuTime3 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtThu3S.Text.Trim() & txtThu3E.Text.Trim())
                Dim FriTime1 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtFri1S.Text.Trim() & txtSun1E.Text.Trim())
                Dim FriTime2 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtFri2S.Text.Trim() & txtFri2E.Text.Trim())
                Dim FriTime3 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtFri3S.Text.Trim() & txtFri3E.Text.Trim())
                Dim SatTime1 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSat1S.Text.Trim() & txtSat1E.Text.Trim())
                Dim SatTime2 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSat2S.Text.Trim() & txtSat2E.Text.Trim())
                Dim SatTime3 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSat3S.Text.Trim() & txtSat3E.Text.Trim())
                Dim Hol1Time1 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol11S.Text.Trim() & txtHol11E.Text.Trim())
                Dim Hol1Time2 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol12S.Text.Trim() & txtHol12E.Text.Trim())
                Dim Hol1Time3 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol13S.Text.Trim() & txtHol13E.Text.Trim())
                Dim Hol2Time1 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol21S.Text.Trim() & txtHol21E.Text.Trim())
                Dim Hol2Time2 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol22S.Text.Trim() & txtHol22E.Text.Trim())
                Dim Hol2Time3 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol23S.Text.Trim() & txtHol23E.Text.Trim())
                Dim Hol3Time1 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol31S.Text.Trim() & txtHol31E.Text.Trim())
                Dim Hol3Time2 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol32S.Text.Trim() & txtHol32E.Text.Trim())
                Dim Hol3Time3 As Long = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol33S.Text.Trim() & txtHol33E.Text.Trim())


                sdk.SetTimezoneData(TimezoneId, SunTime1, SunTime2, SunTime3, MonTime1, MonTime2, _
                 MonTime3, TueTime1, TueTime2, TueTime3, WedTime1, WedTime2, _
                 WedTime3, ThuTime1, ThuTime2, ThuTime3, FriTime1, FriTime2, _
                 FriTime3, SatTime1, SatTime2, SatTime3, Hol1Time1, Hol1Time2, _
                 Hol1Time3, Hol2Time1, Hol2Time2, Hol2Time3, Hol3Time1, Hol3Time2, _
                 Hol3Time3)

                If sdk.Keylock_WriteAllDataToDevice(txtPath.Text.Trim()) Then
                    ShowCurrentStatus("Successfully upload timezone")
                Else
                    ShowCurrentStatus("Failed to upload timezone")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

    Private Sub btnClearTimezone_Click(sender As Object, e As EventArgs) Handles btnClearTimezone.Click
        Try
            If IsUDiskPathValid() Then
                If sdk.Keylock_ClearTimezoneData(txtPath.Text.Trim()) Then
                    ShowCurrentStatus("Successfully clear timezone data")
                Else
                    ShowCurrentStatus("Failed to clear timezone data")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

    Private Sub btnGetAllTimezone_Click(sender As Object, e As EventArgs) Handles btnGetAllTimezone.Click
        Try
            If IsUDiskPathValid() Then
                If sdk.Keylock_ReadAllDeviceData(txtPath.Text.Trim(), clsConst.TableName_Display_TimeZone) Then

                    Dim TimezoneId As Integer = 0
                    Dim SunTime1 As Long = 0
                    Dim SunTime2 As Long = 0
                    Dim SunTime3 As Long = 0
                    Dim MonTime1 As Long = 0
                    Dim MonTime2 As Long = 0
                    Dim MonTime3 As Long = 0
                    Dim TueTime1 As Long = 0
                    Dim TueTime2 As Long = 0
                    Dim TueTime3 As Long = 0
                    Dim WedTime1 As Long = 0
                    Dim WedTime2 As Long = 0
                    Dim WedTime3 As Long = 0
                    Dim ThuTime1 As Long = 0
                    Dim ThuTime2 As Long = 0
                    Dim ThuTime3 As Long = 0
                    Dim FriTime1 As Long = 0
                    Dim FriTime2 As Long = 0
                    Dim FriTime3 As Long = 0
                    Dim SatTime1 As Long = 0
                    Dim SatTime2 As Long = 0
                    Dim SatTime3 As Long = 0
                    Dim Hol1Time1 As Long = 0
                    Dim Hol1Time2 As Long = 0
                    Dim Hol1Time3 As Long = 0
                    Dim Hol2Time1 As Long = 0
                    Dim Hol2Time2 As Long = 0
                    Dim Hol2Time3 As Long = 0
                    Dim Hol3Time1 As Long = 0
                    Dim Hol3Time2 As Long = 0
                    Dim Hol3Time3 As Long = 0

                    ShowCurrentStatus(clsConst.TableName_TimeZone_Col)

                    While sdk.GetTimezoneData(TimezoneId, SunTime1, SunTime2, SunTime3, MonTime1, MonTime2, _
                     MonTime3, TueTime1, TueTime2, TueTime3, WedTime1, WedTime2, _
                     WedTime3, ThuTime1, ThuTime2, ThuTime3, FriTime1, FriTime2, _
                     FriTime3, SatTime1, SatTime2, SatTime3, Hol1Time1, Hol1Time2, _
                     Hol1Time3, Hol2Time1, Hol2Time2, Hol2Time3, Hol3Time1, Hol3Time2, _
                     Hol3Time3)
                        ShowCurrentStatus(TimezoneId & "," & SunTime1 & "," & SunTime2 & "," & SunTime3 & "," & MonTime1 & "," & MonTime2 & "," & MonTime3 & "," & TueTime1 & "," & TueTime2 & "," & TueTime3 & "," & WedTime1 & "," & WedTime2 & "," & WedTime3 & "," & ThuTime1 & "," & ThuTime2 & "," & ThuTime3 & "," & FriTime1 & "," & FriTime2 & "," & FriTime3 & "," & SatTime1 & "," & SatTime2 & "," & SatTime3 & "," & Hol1Time1 & "," & Hol1Time2 & "," & Hol1Time3 & "," & Hol2Time1 & "," & Hol2Time2 & "," & Hol2Time3 & "," & Hol3Time1 & "," & Hol3Time2 & "," & Hol3Time3)
                    End While
                Else
                    ShowCurrentStatus("No record found")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

	#End Region

	#Region "Template"
    Private Sub btnSetTemp_Click(sender As Object, e As EventArgs) Handles btnSetTemp.Click
        Try
            If IsUDiskPathValid() Then
                Dim userid As Integer = Convert.ToInt32(txtTemplateUser.Text.Trim())
                Dim fingerid As Integer = Convert.ToInt32(txtTemplateFinger.Text.Trim())
                Dim valid As Integer = Convert.ToInt32(txtTempValid.Text.Trim())
                Dim template As String = txtTemplate.Text.Trim()

                sdk.SetUserTemplate(userid, fingerid, valid, template)
                If sdk.Keylock_WriteAllDataToDevice(txtPath.Text.Trim()) Then
                    ShowCurrentStatus("Successfully upload user template")
                Else
                    ShowCurrentStatus("Failed to upload user template")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

    Private Sub btnGetAllTemp_Click(sender As Object, e As EventArgs) Handles btnGetAllTemp.Click
        Try
            If IsUDiskPathValid() Then
                If sdk.Keylock_ReadAllDeviceData(txtPath.Text.Trim(), clsConst.TableName_Display_Template) Then
                    Dim userid As Integer = 0
                    Dim fingerid As Integer = 0
                    Dim valid As Integer = 0
                    Dim template As String = String.Empty

                    ShowCurrentStatus(clsConst.TableName_Template_Col)
                    ' "UserID,FingerID,Valid,Template";

                    While sdk.GetUserTemplate(userid, fingerid, valid, template)
                        ShowCurrentStatus(userid & "," & fingerid & "," & valid & "," & template)
                    End While
                Else
                    ShowCurrentStatus("No record found.")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub

    Private Sub btnClearTemplate_Click(sender As Object, e As EventArgs) Handles btnClearTemplate.Click
        Try
            If IsUDiskPathValid() Then
                If sdk.Keylock_ClearUserTemplate(txtPath.Text.Trim()) Then
                    ShowCurrentStatus("Successfully clear user template")
                Else
                    ShowCurrentStatus("Failed to clear user template")
                End If
            End If
        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub
	#End Region

	#Region "General Log"
    Private Sub btnGetAllGeneral_Click(sender As Object, e As EventArgs) Handles btnGetAllGeneral.Click
        Try
            If IsUDiskPathValid() Then
                Dim dialog As New System.Windows.Forms.OpenFileDialog
                dialog.CheckFileExists = True
                dialog.CheckPathExists = True
                dialog.InitialDirectory = txtPath.Text.Trim()
                 
                If dialog.ShowDialog = Windows.Forms.DialogResult.OK Then
                    Dim sData As String = String.Empty

                    If sdk.Keylock_DecryptLog(dialog.FileName, sData) Then
                        If sData Is Nothing Then
                            ShowCurrentStatus("No record found")
                        Else
                            ShowCurrentStatus(sData)
                        End If
                    End If
                  
                End If
            End If 

        Catch ex As Exception
            ShowCurrentStatus(ex.Message)
        End Try
    End Sub 
	 
	#End Region

    Private Sub txtTemplate_KeyDown(sender As Object, e As KeyEventArgs) Handles txtTemplate.KeyDown
        Try
            If e.Control AndAlso (e.KeyCode = System.Windows.Forms.Keys.A) Then
                txtTemplate.SelectAll()
                e.SuppressKeyPress = True
                e.Handled = True
            Else
                MyBase.OnKeyDown(e)
            End If
        Catch
        End Try
    End Sub

    Private Sub btnBrowse_Click(sender As Object, e As EventArgs) Handles btnBrowse.Click
        Try
            Dim file As New FolderBrowserDialog()
            file.ShowNewFolderButton = False
            file.RootFolder = Environment.SpecialFolder.MyComputer

            If file.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                txtPath.Text = file.SelectedPath
                sdk = New Ingressus.Ingressus()
            End If
        Catch
        End Try
    End Sub








End Class



