﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
 
namespace uDiskDemo
{
    public partial class Form1 : Form
    {
        Ingressus.Ingressus sdk = null;
        public Form1()
        {
            try
            {
                InitializeComponent();
            }
            catch { }
        } 
      
        protected void ShowCurrentStatus(string msg)
        {
            try
            {
                if (txtCurrentStatus.Text.Length >= txtCurrentStatus.MaxLength )
                {
                    txtCurrentStatus.Text = string.Empty;
                }

                txtCurrentStatus.Text += msg + "\r\n";
                txtCurrentStatus.SelectionStart = txtCurrentStatus.Text.Length;
                txtCurrentStatus.ScrollToCaret();
               
                System.Windows.Forms.Application.DoEvents();
            }
            catch (Exception ex) { txtCurrentStatus.Text += ex.Message; }
        }

        protected bool IsUDiskPathValid()
        {
            if (System.IO.Directory.Exists(txtPath.Text.Trim()))
            {
                return true;
            }
            else
            {
                ShowCurrentStatus("Invalid uDisk Path");
                return false;
            } 
        }
      
        private void btnClear_Click(object sender, EventArgs e)
        {
            txtCurrentStatus.Text = string.Empty;
            System.Windows.Forms.Application.DoEvents();
        }
         
        /* 
         *  P/S :
         *  Demo is set table data One by One
         *  You may write all data to buffer, then only use function WriteAllDataToDevice_Keylock() upload to keylock.
         *  
         */
    
        #region User
        private void btnGetAllUser_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    if (sdk.Keylock_ReadAllDeviceData (txtPath.Text.Trim(), clsConst.TableName_Display_User))
                    { 
                        int userid = 0;
                        int privilege = 0;
                        string username = string.Empty;
                        string cardnum = string.Empty;
                        int multicard = 0;
                        string password = string.Empty;
                        string issuetime = string.Empty;
                        string expiretime = string.Empty;

                        ShowCurrentStatus(clsConst.TableName_User_Col);
                        //"UserID,Privilege,Username,CardNum,MulticardGroup,Password,IssueTime,ExpireTime";

                        while (sdk.GetUserInfo(out userid, out privilege, out username, out cardnum, out multicard, out password, out issuetime, out expiretime))
                        {
                            ShowCurrentStatus(userid + "," + privilege + "," + username + "," + cardnum + "," + multicard + "," + password + "," + issuetime + "," + expiretime);
                        }
                    }
                    else
                    {
                        ShowCurrentStatus("No record found.");
                    }
                } 
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }

        private void btnSetUser_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    int userid = Convert.ToInt32(txtUserID.Text.Trim());
                    int privilege = Convert.ToInt32(txtPrivilege.Text.Trim());
                    string username = txtUserName.Text.Trim();
                    string cardnum = txtCardNum.Text.Trim();
                    int multicard = Convert.ToInt32(txtMulticardGroup.Text.Trim());
                    string password = txtPassword.Text.Trim();
                    string issuetime = Convert.ToDateTime(txtStartTime.Text.Trim()).ToString("yyyyMMdd");
                    string expiretime = Convert.ToDateTime(txtExpireTime.Text.Trim()).ToString("yyyyMMdd");
                     
                    sdk.SetUserInfo(userid, privilege, username, cardnum, multicard, password, issuetime, expiretime);
                    if (sdk. Keylock_WriteAllDataToDevice(txtPath.Text.Trim()))// upload user to Ingresuss  
                    {
                        ShowCurrentStatus("Successfully upload user");
                    }
                    else
                    {
                        ShowCurrentStatus("Failed to upload user");
                    } 
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }

        private void btnClearUser_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    if (sdk.Keylock_ClearUserInfo(txtPath.Text.Trim()))
                    {
                        ShowCurrentStatus("Successfully clear user info");
                    }
                    else
                    {
                        ShowCurrentStatus("Failed to clear user info");
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }
        #endregion

        #region User Access Level 

        private void btnSetUserAL_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    int userid = Convert.ToInt32(txtALUser.Text.Trim());
                    int timezoneid = Convert.ToInt32(txtALTimezone.Text.Trim());
                    int doorid = Convert.ToInt32(txtALDoor.Text.Trim());

                    sdk.SetUserAccessLevel(userid, timezoneid, doorid);
                    if (sdk.Keylock_WriteAllDataToDevice(txtPath.Text.Trim()))
                    {
                        ShowCurrentStatus("Successfully upload user access level");
                    }
                    else
                    {
                        ShowCurrentStatus("Failed to upload user access level");
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }
 
        private void btnGetAllAL_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    if (sdk.Keylock_ReadAllDeviceData(txtPath.Text.Trim(), clsConst.TableName_Display_UserAccessLevel))
                    {
                        int userid = 0;
                        int timezoneid = 0;
                        int doorid = 0;

                        ShowCurrentStatus(clsConst.TableName_UserAccessLevel_Col);
                        //"UserID,AuthorizeTimezoneId,AuthorizeDoorId";

                        while (sdk.GetUserAccessLevel(out userid, out timezoneid, out doorid))
                        {
                            ShowCurrentStatus(userid + "," + timezoneid + "," + doorid);
                        }
                    }
                    else
                    {
                        ShowCurrentStatus("No record found.");
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }

        private void btnClearAL_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    if (sdk.Keylock_ClearUserAccessLevel(txtPath.Text.Trim()))
                    {
                        ShowCurrentStatus("Successfully clear access level data");
                    }
                    else
                    {
                        ShowCurrentStatus("Failed to clear access level data");
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }
        #endregion

        #region Holiday

        private void btnSetHoliday_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    string holiday = txtHoliday.Text.Trim();
                    int holidaytype =Convert.ToInt32(txtHolidayType.Text.Trim());
                    int loop = Convert.ToInt32(txtLoop.Text.Trim());

                    sdk.SetHolidayData(  holiday,   holidaytype,   loop);
                    if (sdk. Keylock_WriteAllDataToDevice (txtPath.Text.Trim()))
                    {
                        ShowCurrentStatus("Successfully upload holiday"); 
                    }
                    else
                    {
                        ShowCurrentStatus("Failed to upload holiday");
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }
         
        private void btnGetAllHoliday_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    if (sdk.Keylock_ReadAllDeviceData(txtPath.Text.Trim(), clsConst.TableName_Display_Holiday))
                    {
                        string holiday = string.Empty;
                        int holidaytype = 0;
                        int loop = 0;

                        ShowCurrentStatus(clsConst.TableName_Holiday_Col);
                        //"Holiday,HolidayType,Loop";

                        while (sdk.GetHolidayData(out holiday, out holidaytype, out loop))
                        {
                            ShowCurrentStatus(holiday + "," + holidaytype + "," + loop);
                        }
                    }
                    else
                    {
                        ShowCurrentStatus("No record found.");
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    if (sdk.Keylock_ClearHolidayData(txtPath.Text.Trim()))
                    {
                        ShowCurrentStatus("Successfully clear holiday data");
                    }
                    else
                    {
                        ShowCurrentStatus("Failed to clear holiday data");
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }

        #endregion

        #region Timezone

        private void btnSetTimezone_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                { 
                    int TimezoneId = Convert.ToInt32(txtTimezoneID.Text.Trim());
                    long SunTime1 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSun1S.Text.Trim() + txtSun1E.Text.Trim()); // starttime + endtime, must be 8digits
                    long SunTime2 =  clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSun2S.Text.Trim() + txtSun2E.Text.Trim());
                    long SunTime3 =  clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSun3S.Text.Trim() + txtSun3E.Text.Trim());
                    long MonTime1 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtMon1S.Text.Trim() + txtMon1E.Text.Trim());
                    long MonTime2 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtMon2S.Text.Trim() + txtMon2E.Text.Trim());
                    long MonTime3 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtMon3S.Text.Trim() + txtMon3E.Text.Trim());
                    long TueTime1 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtTue1S.Text.Trim() + txtTue1E.Text.Trim());
                    long TueTime2 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtTue2S.Text.Trim() + txtTue2E.Text.Trim());
                    long TueTime3 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtTue3S.Text.Trim() + txtTue3E.Text.Trim());
                    long WedTime1 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtWed1S.Text.Trim() + txtWed1E.Text.Trim());
                    long WedTime2 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtWed2S.Text.Trim() + txtWed2E.Text.Trim());
                    long WedTime3 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtWed3S.Text.Trim() + txtWed3E.Text.Trim());
                    long ThuTime1 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtThu1S.Text.Trim() + txtThu1E.Text.Trim());
                    long ThuTime2 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtThu2S.Text.Trim() + txtThu2E.Text.Trim());
                    long ThuTime3 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtThu3S.Text.Trim() + txtThu3E.Text.Trim());
                    long FriTime1 =  clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtFri1S.Text.Trim() + txtSun1E.Text.Trim());
                    long FriTime2 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtFri2S.Text.Trim() + txtFri2E.Text.Trim());
                    long FriTime3 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtFri3S.Text.Trim() + txtFri3E.Text.Trim());
                    long SatTime1 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSat1S.Text.Trim() + txtSat1E.Text.Trim());
                    long SatTime2 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSat2S.Text.Trim() + txtSat2E.Text.Trim());
                    long SatTime3 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtSat3S.Text.Trim() + txtSat3E.Text.Trim());
                    long Hol1Time1 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol11S.Text.Trim() + txtHol11E.Text.Trim());
                    long Hol1Time2 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol12S.Text.Trim() + txtHol12E.Text.Trim());
                    long Hol1Time3 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol13S.Text.Trim() + txtHol13E.Text.Trim());
                    long Hol2Time1 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol21S.Text.Trim() + txtHol21E.Text.Trim());
                    long Hol2Time2 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol22S.Text.Trim() + txtHol22E.Text.Trim());
                    long Hol2Time3 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol23S.Text.Trim() + txtHol23E.Text.Trim());
                    long Hol3Time1 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol31S.Text.Trim() + txtHol31E.Text.Trim());
                    long Hol3Time2 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol32S.Text.Trim() + txtHol32E.Text.Trim());
                    long Hol3Time3 = clsFuncs.ConvertTimezoneTimeFormat_ToDecimal(txtHol33S.Text.Trim() + txtHol33E.Text.Trim());

                  
                    sdk.SetTimezoneData(TimezoneId, SunTime1, SunTime2, SunTime3,
                                 MonTime1, MonTime2, MonTime3, TueTime1, TueTime2, TueTime3,
                                 WedTime1, WedTime2, WedTime3, ThuTime1, ThuTime2, ThuTime3,
                                 FriTime1, FriTime2, FriTime3, SatTime1, SatTime2, SatTime3,
                                 Hol1Time1, Hol1Time2, Hol1Time3, Hol2Time1, Hol2Time2, Hol2Time3,
                                 Hol3Time1, Hol3Time2, Hol3Time3);

                    if (sdk.Keylock_WriteAllDataToDevice  (txtPath.Text.Trim()))
                    {
                        ShowCurrentStatus("Successfully upload timezone");
                    }
                    else
                    {
                        ShowCurrentStatus("Failed to upload timezone");
                    } 
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }

        private void btnClearTimezone_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    if (sdk.Keylock_ClearTimezoneData(txtPath.Text.Trim()))
                    {
                        ShowCurrentStatus("Successfully clear timezone data");
                    }
                    else
                    {
                        ShowCurrentStatus("Failed to clear timezone data");
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }

        private void btnGetAllTimezone_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    if (sdk.Keylock_ReadAllDeviceData(txtPath.Text.Trim(), clsConst.TableName_Display_TimeZone))
                    {

                        int TimezoneId = 0;
                        long SunTime1 = 0;
                        long SunTime2 = 0;
                        long SunTime3 = 0;
                        long MonTime1 = 0;
                        long MonTime2 = 0;
                        long MonTime3 = 0;
                        long TueTime1 = 0;
                        long TueTime2 = 0;
                        long TueTime3 = 0;
                        long WedTime1 = 0;
                        long WedTime2 = 0;
                        long WedTime3 = 0;
                        long ThuTime1 = 0;
                        long ThuTime2 = 0;
                        long ThuTime3 = 0;
                        long FriTime1 = 0;
                        long FriTime2 = 0;
                        long FriTime3 = 0;
                        long SatTime1 = 0;
                        long SatTime2 = 0;
                        long SatTime3 = 0;
                        long Hol1Time1 = 0;
                        long Hol1Time2 = 0;
                        long Hol1Time3 = 0;
                        long Hol2Time1 = 0;
                        long Hol2Time2 = 0;
                        long Hol2Time3 = 0;
                        long Hol3Time1 = 0;
                        long Hol3Time2 = 0;
                        long Hol3Time3 = 0;

                        ShowCurrentStatus(clsConst.TableName_TimeZone_Col);

                        while (sdk.GetTimezoneData(out  TimezoneId, out  SunTime1, out  SunTime2, out  SunTime3,
                                        out  MonTime1, out  MonTime2, out  MonTime3, out  TueTime1, out  TueTime2, out  TueTime3,
                                        out  WedTime1, out  WedTime2, out  WedTime3, out  ThuTime1, out  ThuTime2, out  ThuTime3,
                                        out  FriTime1, out  FriTime2, out  FriTime3, out  SatTime1, out  SatTime2, out  SatTime3,
                                        out  Hol1Time1, out  Hol1Time2, out  Hol1Time3, out  Hol2Time1, out  Hol2Time2, out  Hol2Time3,
                                        out  Hol3Time1, out  Hol3Time2, out  Hol3Time3))
                        {
                            ShowCurrentStatus(TimezoneId + "," + SunTime1 + "," + SunTime2 + "," + SunTime3 + "," + MonTime1 + "," + MonTime2 + "," + MonTime3 + "," + TueTime1 + "," + TueTime2 + "," + TueTime3 + "," + WedTime1 + "," + WedTime2 + "," + WedTime3 + "," + ThuTime1 + "," + ThuTime2 + "," + ThuTime3 + "," + FriTime1 + "," + FriTime2 + "," + FriTime3 + "," + SatTime1 + "," + SatTime2 + "," + SatTime3 + "," + Hol1Time1 + "," + Hol1Time2 + "," + Hol1Time3 + "," + Hol2Time1 + "," + Hol2Time2 + "," + Hol2Time3 + "," + Hol3Time1 + "," + Hol3Time2 + "," + Hol3Time3);
                        }
                    }
                    else
                    {
                        ShowCurrentStatus("No record found");
                    } 
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }
        
        #endregion
         
        #region Template
        private void btnSetTemp_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                { 
                    int userid = Convert.ToInt32(txtTemplateUser.Text.Trim());
                    int fingerid = Convert.ToInt32(txtTemplateFinger.Text.Trim());
                    int valid = Convert.ToInt32(txtTempValid.Text.Trim());
                    string template = txtTemplate.Text.Trim();

                    sdk.SetUserTemplate(userid, fingerid, valid, template);
                    if (sdk.Keylock_WriteAllDataToDevice(txtPath.Text.Trim()))
                    {
                        ShowCurrentStatus("Successfully upload user template");
                    }
                    else
                    {
                        ShowCurrentStatus("Failed to upload user template");
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }

        private void btnGetAllTemp_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    if (sdk.Keylock_ReadAllDeviceData (txtPath.Text.Trim(), clsConst.TableName_Display_Template))
                    {
                        int userid = 0;
                        int fingerid = 0;
                        int valid = 0;
                        string template = string.Empty;

                        ShowCurrentStatus(clsConst.TableName_Template_Col);
                        // "UserID,FingerID,Valid,Template";

                        while (sdk.GetUserTemplate(out userid, out fingerid, out valid, out template))
                        {
                            ShowCurrentStatus(userid + "," + fingerid + "," + valid + "," + template);
                        }
                    }
                    else
                    {
                        ShowCurrentStatus("No record found.");
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }

        private void btnClearTemplate_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    if (sdk.Keylock_ClearUserTemplate(txtPath.Text.Trim()))
                    {
                        ShowCurrentStatus("Successfully clear user template");
                    }
                    else
                    {
                        ShowCurrentStatus("Failed to clear user template");
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        }
        #endregion

        #region General Log
        private void btnGetAllGeneral_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsUDiskPathValid())
                {
                    System.Windows.Forms.OpenFileDialog dialog = new OpenFileDialog();
                    dialog.CheckFileExists = true;
                    dialog.CheckPathExists = true;
                    dialog.InitialDirectory = txtPath.Text.Trim();

                    if (dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                    { 
                        string sData = string.Empty; 
                        if (sdk.Keylock_DecryptLog(dialog.FileName, out sData ))
                        { 
                            if (string.IsNullOrEmpty(sData))
                            {
                                ShowCurrentStatus("No record found");
                            }
                            else
                            {
                                ShowCurrentStatus(sData);
                            }
                        }
                    }
                }
            }
            catch (Exception ex) { ShowCurrentStatus(ex.Message); }
        } 
   
        #endregion

        private void txtTemplate_KeyDown(object sender, KeyEventArgs e)
        {
            try
            {
                if (e.Control && (e.KeyCode == System.Windows.Forms.Keys.A))
                {
                    txtTemplate.SelectAll();
                    e.SuppressKeyPress = true;
                    e.Handled = true;
                }
                else
                    base.OnKeyDown(e);
            }
            catch { }
        }

        private void btnBrowse_Click(object sender, EventArgs e)
        {
            try
            {
                FolderBrowserDialog file = new FolderBrowserDialog();
                file.ShowNewFolderButton = false;
                file.RootFolder = Environment.SpecialFolder.MyComputer;

                if (file.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    txtPath.Text = file.SelectedPath;
                    sdk = new Ingressus.Ingressus();
                } 
            }
            catch { }
        }
          
      

     
     

       

    }



}
