﻿using System;
using System.Collections.Generic;
using System.Text;

namespace uDiskDemo
{
    class clsFuncs
    {
        public static bool ConvertTimezoneTimeFormat_FromDecimal(string timezone, out string startTime, out string endTime)
        {
            try
            {
                long iHexTimezone = Convert.ToInt64(timezone);

                // convert decimal to hex 
                string hexTimezone = iHexTimezone.ToString("X");

                switch (hexTimezone.Length)
                {
                    case 6: hexTimezone = "00" + hexTimezone;
                        break;

                    case 7: hexTimezone = "0" + hexTimezone;
                        break;
                    default: break;
                }

                string hexStartTime = hexTimezone.Substring(0, 4);
                string hexEndTime = hexTimezone.Substring(4, 4);

                int iStartTime = Convert.ToInt32(hexStartTime, 16);
                int iEndTime = Convert.ToInt32(hexEndTime, 16);

                startTime = iStartTime.ToString();
                endTime = iEndTime.ToString();
                return true;
            }
            catch { startTime = string.Empty; endTime = string.Empty; return false; }
        }

        public static long ConvertTimezoneTimeFormat_ToDecimal(string timezone)
        {
            int StartTimeHour = Convert.ToInt32(timezone.Substring(0, 2));
            int StartTimeMinute = Convert.ToInt32(timezone.Substring(2, 2));
            int EndTimeHour = Convert.ToInt32(timezone.Substring(4, 2));
            int EndTimeMinute = Convert.ToInt32(timezone.Substring(6, 2));

            int iStartTime = StartTimeHour * 100 + StartTimeMinute;
            int iEndTime = EndTimeHour * 100 + EndTimeMinute;

            string hexStartTime = iStartTime.ToString("X");
            string hexEndTime = iEndTime.ToString("X");

            switch (hexStartTime.Length)
            {
                case 1:
                    hexStartTime = "000" + hexStartTime;
                    break;
                case 2:
                    hexStartTime = "00" + hexStartTime;
                    break;
                case 3:
                    hexStartTime = "0" + hexStartTime;
                    break;
            }

            switch (hexEndTime.Length)
            {
                case 1:
                    hexEndTime = "000" + hexEndTime;
                    break;
                case 2:
                    hexEndTime = "00" + hexEndTime;
                    break;
                case 3:
                    hexEndTime = "0" + hexEndTime;
                    break;
            }

            return Convert.ToInt64(hexStartTime + hexEndTime, 16);
        }
    }
}
